#[macro_use]
extern crate rocket;

use rocket::fs::FileServer;
use rocket::http::ContentType;
use rocket::tokio::fs::File;
use std::path::Path;

// #[get("/<font>")]
// async fn fonts(font: &str) -> (ContentType, Option<File>) {
//     let filename = Path::new("public/fonts/").join(font);
//     (ContentType::TTF, File::open(&filename).await.ok())
// }

#[get("/")]
async fn index() -> rocket::response::content::RawHtml<String> {
    let mut vdom = dioxus::core::VirtualDom::new(rust_letter::web_app::App);
    let _ = vdom.rebuild();
    let mut output = dioxus_ssr::render(&vdom);
    output = format!(
        "<head><link href=/styles/tailwind.min.css rel=stylesheet /></head>{}",
        output
    )
    .to_string();
    rocket::response::content::RawHtml(output)
}

#[rocket::main]
async fn main() -> Result<(), rocket::Error> {
    let _result = rocket::build()
        .mount("/images", FileServer::from("public/images"))
        .mount("/styles", FileServer::from("public/styles"))
        .mount("/fonts", FileServer::from("public/fonts"))
        .mount("/", routes![index])
        .launch()
        .await?;
    Ok(())
}
